/*
 * CommunitiesHandler.java
 *
 * Created on 25 de agosto de 2004, 17:10
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Community;
import com.fenalco.entities.PaymentMethod;
import com.fenalco.entities.Log;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet controlará las operaciones realizadas sobre las comunidades del
 * sistema, como por ejemplo: - Crear una nueva comunidad - Eliminar una
 * comunidad
 * 
 * @author Nestór Romero León
 */
public class CommunitiesHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuracion
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Para la creación de una nueva comunidad, recibe los datos necesarios para
	 * crear un objeto de tipo <CODE>Community</CODE>:
	 *  - Identificador de la comunidad --> "communityId" - Identificador del
	 * proveedor --> session "user" - Nombre de la comunidad --> "communityName" -
	 * Descripción --> "communityDescription"
	 * 
	 * Con estos datos se crea el objeto y se hace un llamado al método <CODE>
	 * saveData</CODE>, para guardar la comunidad en la base de datos.
	 * 
	 * Para la eliminación de la comunidad, se utiliza simplemente su
	 * identificador en la base de datos. Se construye un objeto de tipo <CODE>
	 * Community</CODE> se asigna el identificador y se hace un llamado al
	 * método <CODE>delete</CODE>.
	 * 
	 * Para los códigos de las operaciones se seguiran las siguientes
	 * convenciones: - 1: Agregar una comunidad - 2: Eliminar una comunidad será
	 * recibido como un parámetro de nombre "operationType".
	 * 
	 * Tanto el método <CODE>saveData</CODE> como <CODE>delete</CODE>
	 * reciben una transacción.
	 * 
	 * Despues de realizar las operaciones se redirecciona el flujo hacia el
	 * servlet <CODE>Comunidades (CommunitiesView)</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message = "";
		boolean flag = true;

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
				String operationType = request.getParameter("operationType");
	
				User supplier = (User) session.getAttribute("user");
				Transaction t = new Transaction();
	
				if( operationType.equals("add") )
				{
					//Agregar una comunidad
					Community community = new Community();
					community.setName(request.getParameter("name"));
					community.setSupplierId(supplier.getCompanyId());
                                        boolean nameExist = community.nameExist( supplier.getCompanyId() );
                                        if( nameExist ){
                                            message = "Ya existe una comunidad con ese nombre";
                                        }
	
					if( nameExist || !community.saveData(t) )
					{
						flag = false;
					}
					else
					{
                                            PaymentMethod pm;
                                            if( request.getParameterValues( "item" ) != null){
                                                
                                                String[] items = request.getParameterValues( "item" );
                                                int key = 0;
                                                for( int i=0; i< items.length; i++ ){

                                                    key = Integer.parseInt( items[i] );
                                                    pm = new PaymentMethod ( key );
                                                    pm.addPaymentMethod( community.getId(), 2, t) ;

                                                }

                                                // guardo el registro en el log
                                                try
                                                {
                                                    Transaction t1 = new Transaction( );
                                                    Log l = new Log( );
                                                    User user = ( User )session.getAttribute( "user" );
                                                    String userId = user.getLogin();
                                                    String numberId = user.getIdentificationNumber();
                                                    String externalUser = "";
                                                    String description = "El proveedor creo la comunidad " + community.getName();
                                                    User callcenter = ( User )session.getAttribute( "callcenter" );
                                                    if( callcenter != null )
                                                    {
                                                        externalUser = callcenter.getLogin();
                                                    }
                                                    l.saveData(userId, numberId, 49, description, externalUser, t );
                                                    t1.execute();
                                                }
                                                catch( Exception ex )
                                                {
                                                    System.out.println( "Error guardando el Log." );
                                                }
                                                
                                            }
                                            
					}
	
				}
				else
					if( operationType.equals("delete") )
					{
						//Eliminar una comunidad
						String[] items = request.getParameterValues("item");
						if( items != null )
						{
							for( int i = 0; i < items.length; i++ )
							{
								Community community = new Community();
								community.setId(new Integer(items[i]).intValue());
								if( !community.delete(t) )
								{
									flag = false;
									break;
								}
								else
								{
									// guardo el registro en el log
				                    try
				                    {
				                        Transaction t1 = new Transaction( );
				                        Log l = new Log( );
				                        User user = ( User )session.getAttribute( "user" );
				                        String userId = user.getLogin();
				                        String numberId = user.getIdentificationNumber();
				                        String externalUser = "";
				                        String description = "El proveedor eliminó la comunidad " + community.getName();
				                        User callcenter = ( User )session.getAttribute( "callcenter" );
				                        if( callcenter != null )
				                        {
				                            externalUser = callcenter.getLogin();
				                        }
				                        l.saveData(userId, numberId, 57, description, externalUser, t );
				                        t1.execute();
				                    }
				                    catch( Exception ex )
				                    {
				                        System.out.println( "Error guardando el Log." );
				                    }
	
								}
							}
						}
						else
						{
							flag = false;
						}
	
					}
	
				if( !flag || !t.execute() )
				{
					//Fallo en la transacción
					url = "/proveedor/comunidades";
					//message = "Error al actualizar el conjunto de comunidades";
					//message = MessageBuilder.buildMessage(7);
	
				}
				else
				{
					//Todo OK
					url = "/proveedor/comunidades";
					//message = "La actualización del conjunto de comunidades
					// finalizó correctamente ";
					message = MessageBuilder.buildMessage(4);
				}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Breve descripción del servlet.
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}